﻿/*
The author of this Script is Hidetoshi Iizawa.
(C) Copyright Me. All Rights Reserved.

@@@BUILDINFO@@@ CS5_AbsolutePathRep_ver1.13.jsx !Version! Mon Jul 02 2012 16:10:16 GMT+0900
ver 1.00 12/06/26: 公開しました。
ver 1.01 12/06/27: 空白を入力した場合、AEPからの相対パスで置き換えます。
ver 1.02 12/06/27: ESTK以外からの実行でエラーとなる問題を修正。
ver 1.02 12/06/27: fileがNULLのとき保存を促す。
ver 1.10 12/06/27: replaceとreplaceWithSequenceを分岐。
ver 1.11 12/06/28: proxyに対応。
ver 1.12 12/06/28: 残り不明ファイル数をmaiとproxyに分けた。
ver 1.13 12/07/02: 残りproxy数がおかしい問題を修正。
ver 1.14 13/2/07: フッテージが全てストレートカラーになる問題を修正。
ver 1.15 16/2/17: footageItem.mainSource.removePulldown = 5013;をfootageItem.mainSource.removePulldown = PulldownPhase.OFF;に修正。

*/

(function(){
	app.beginUndoGroup("CS5_AbsolutePathRep");
	//----------------------------------------------------------------------------------------
	function pathBoxWindow()
	{
		this.title = "Pathを入力してください";
		this.pathStr = "";
		//-------------------------------------------------
		this.getEditText = function()
		{
			this.pathStr = this.pathEdit.text;
			return true;
		}
		this.clickBtn = function ()
		{
			if(app.project.file!=null)
			{
				var projFolderPath　= File.decode(app.project.file.parent) + "\\(Footage)";
			}else{
				var projFolderPath　= "";
			}
			
			newLocation = Folder.selectDialog("フォルダを指定してください",projFolderPath);
			if(newLocation)
			{
				this.parent.children['pathBox'].text = File.decode(newLocation.toString())+"/";
				//alert(this.parent.children[1]);
			}
		}
		//-------------------------------------------------
		this.buildAndShowDialog = function ()
		{
			var jTextPane = [10,45,10+430,45+20];//※空白を入力でAEPからの相対パスで置き換えます")
			var jTextPane2 = [10,65,10+430,65+20];//※マイコンピュータは指定しないでください")
			
			
			var textField = [10,20,10+335,20+20];//path入力Box
			var pathBtn = [350,20,410,20+20];//読み込み
			
			this.dialog = new Window("dialog","FolderPathRep");
			this.dialog.bounds = [600,340,1020,480];
			this.dialog.savaOverIndex = this.savaOverIndex;
			//staticText
			var st = this.dialog.add("statictext", jTextPane, "※空白を入力でAEPからの相対パスで置き換えます");
			var st2 = this.dialog.add("statictext", jTextPane2, "※マイコンピュータは指定しないでください");
			st.justify = "left";
			st2.justify = "left";
			//editText
			this.pathEdit = this.dialog.add("edittext", textField, this.pathStr,{name:'pathBox'});
			//パス読み込みボタン
			var pBtn    	= this.dialog.add("button", pathBtn, "読み込み",{name:'read'} );
			pBtn.onClick = this.clickBtn;

			var okBtn = this.dialog.add("button", [230, 90, 310, 115], "実行",{name:'ok'} );
			var cancelBtn = this.dialog.add("button", [320, 90, 410, 115], "キャンセル", {name:'cancel'});
			
			 this.dialog.center();
			return this.dialog.show();
		}
		this.execute = function ()
		{
			var result =false;
			var r = this.buildAndShowDialog();
			this.left	= this.dialog.bounds.left;
			this.top	= this.dialog.bounds.top;
			if (r==1){
				result =true;
			}
			this.getEditText();
			return result;
		}
	}
	//----------------------------------------------------------------------------------------	
	var pNum = app.project.numItems;
	var repCnt = 0;
	var m = 0;
	var p = 0;
	var w =new pathBoxWindow();
	
	if(app.project.file==null){
		app.project.save();
	}
	
	if (w.execute()==true){
		var repStr = "(Footage)";
		if(w.pathStr.indexOf(repStr)!=-1||w.pathStr==""){
			for(var i=1;i<=pNum;i++){
				if(app.project.item(i) instanceof FootageItem){
					if(app.project.item(i).mainSource instanceof FileSource){
						if(app.project.item(i).mainSource.file.exists == false){
							var footageItem = app.project.item(i);
							var filePath = File.decode(footageItem.mainSource.file.fsName)
							//ファイルパスを入力後のパスで置き換え
							var p = filePath.indexOf(repStr);
							if(p!=-1){
								var cutPath = filePath.substring(p+repStr.length,filePath.length);
								if(w.pathStr!=""){
									var newPath = w.pathStr + cutPath;
								}else{
									var projFolderPath	= File.decode(app.project.file.parent);
									var newPath =  projFolderPath + "\\(Footage)"+ cutPath;
								}
								if(File(newPath).exists==true)
								{
									//aiとpsdの/をスキップ
										//静止画かシーケンスか判定
										var still = footageItem.mainSource.isStill;
										//フッテージ変換を定義しておく
										var ftgHasAlpha = footageItem.mainSource.hasAlpha;
										var ftgAlphaMode = footageItem.mainSource.alphaMode;
										var ftgPremulColor = footageItem.mainSource.premulColor;
										var ftgInvertAlpha = footageItem.mainSource.invertAlpha;
										var ftgFieldSeparationType = footageItem.mainSource.fieldSeparationType;
										var ftgHighQualityFieldSeparation = footageItem.mainSource.highQualityFieldSeparation;
										var ftgRemovePulldown = footageItem.mainSource.removePulldown;
										var ftgLoop = footageItem.mainSource.loop;
										var ftgConformFrameRate = footageItem.mainSource.conformFrameRate;
										
										if(still==false){
											if(File(newPath).exists==true){
												//連番と動画を判定する
												var cfFrameRate = footageItem.mainSource.conformFrameRate;
												//PulldownPhase.RemovePulldown.OFFでないと変更できない											
												footageItem.mainSource.removePulldown = PulldownPhase.OFF;
												footageItem.mainSource.conformFrameRate = 0;
												if(footageItem.mainSource.conformFrameRate==0){
													footageItem.replace(File(newPath));
												}else{
													footageItem.replaceWithSequence(File(newPath),false);
												}
												try{
													footageItem.mainSource.conformFrameRate = cfFrameRate;
												}catch(err){
												}
											}
											footageItem.mainSource.fieldSeparationType = ftgFieldSeparationType;
											//動画にも使えない？
											if(footageItem.mainSource.fieldSeparationType.OFF)
											{
												footageItem.mainSource.highQualityFieldSeparation = ftgHighQualityFieldSeparation;		
											}																								
											footageItem.mainSource.removePulldown = ftgRemovePulldown;
											footageItem.mainSource.loop = ftgLoop;
											footageItem.mainSource.conformFrameRate = ftgConformFrameRate;
										}else{
											if(File(newPath).exists==true){
												footageItem.replace(File(newPath));
											}
										}
									
										//フッテージ変換の値を適用する
										// footageItem.mainSource.hasAlpha = ftgHasAlpha;
										footageItem.mainSource.alphaMode = ftgAlphaMode;
										footageItem.mainSource.premulColor = ftgPremulColor;
										footageItem.mainSource.invertAlpha = ftgInvertAlpha;
										
										repCnt+=1;
									
								}
							}
						}
					}
				}
				//
				if(app.project.item(i).useProxy){
					if(app.project.item(i).proxySource instanceof FileSource){
						if(app.project.item(i).proxySource.file.exists == false){
							var footageItem = app.project.item(i);
							var filePath = File.decode(footageItem.proxySource.file.fsName)
							//ファイルパスを入力後のパスで置き換え
							var p = filePath.indexOf(repStr);
							if(p!=-1){
								var cutPath = filePath.substring(p+repStr.length,filePath.length);
								if(w.pathStr!=""){
									var newPath = w.pathStr + cutPath;
								}else{
									var projFolderPath	= File.decode(app.project.file.parent);
									var newPath =  projFolderPath + "\\(Footage)"+ cutPath;
								}
								if(File(newPath).exists==true){									
									//静止画かシーケンスか判定
									var still = footageItem.proxySource.isStill;

									//フッテージ変換を定義しておく
									var ftgHasAlpha = footageItem.proxySource.hasAlpha;
									var ftgAlphaMode = footageItem.proxySource.alphaMode;
									var ftgPremulColor = footageItem.proxySource.premulColor;
									var ftgInvertAlpha = footageItem.proxySource.invertAlpha;
									var ftgFieldSeparationType = footageItem.proxySource.fieldSeparationType;
									var ftgHighQualityFieldSeparation = footageItem.proxySource.highQualityFieldSeparation;
									var ftgRemovePulldown = footageItem.proxySource.removePulldown;
									var ftgLoop = footageItem.proxySource.loop;
									var ftgConformFrameRate = footageItem.proxySource.conformFrameRate;
									
									if(still==false){
										if(File(newPath).exists==true){
											//連番と動画を判定する
											var cfFrameRate = footageItem.proxySource.conformFrameRate;
											footageItem.proxySource.removePulldown = PulldownPhase.OFF;
											footageItem.proxySource.conformFrameRate = 0;
											if(footageItem.proxySource.conformFrameRate==0){
												footageItem.setProxy(File(newPath));
											}else{
												footageItem.setProxyWithSequence(File(newPath),false);
											}
											try{
												footageItem.proxySource.conformFrameRate = cfFrameRate;
											}catch(err){
											}
											//これは静止画には使えない
											footageItem.proxySource.fieldSeparationType = ftgFieldSeparationType;
											footageItem.proxySource.highQualityFieldSeparation = ftgHighQualityFieldSeparation;
											footageItem.proxySource.removePulldown = ftgRemovePulldown;
											footageItem.proxySource.loop = ftgLoop;
											footageItem.proxySource.conformFrameRate = ftgConformFrameRate;
										}
									}else{
										if(File(newPath).exists==true){
											footageItem.setProxy(File(newPath));
										}
									}
									//フッテージ変換の値を適用する
									// footageItem.proxySource.hasAlpha = ftgHasAlpha;
									footageItem.proxySource.alphaMode = ftgAlphaMode;
									footageItem.proxySource.premulColor = ftgPremulColor;
									footageItem.proxySource.invertAlpha = ftgInvertAlpha;
									repCnt+=1;
								}
							}
						}
					}
				}
			//
			}
			var p = 0;
			for(var i=1;i<=pNum;i++){
				if(app.project.item(i) instanceof FootageItem){
					if(app.project.item(i).mainSource instanceof FileSource){
						if(app.project.item(i).mainSource.file.exists == false){
							m+=1;
						}
					}
				}
				if(app.project.item(i).useProxy){
					if(app.project.item(i).useProxy==true){
						if(app.project.item(i).proxySource instanceof FileSource){						
							if(app.project.item(i).proxySource.file.exists == false){
								p+=1;
							}
						}
					}
				}
			}
			alert(repCnt + "個の置き換えに成功しました。\n" + m +"個の不明mainSourceが残っています。\n" + p +"個の不明proxySourceが残っています。");
		}else{
			alert("置き換え後のパスに\"\\(Footage)\"を含めてください");
		}
	}
	
	//----------------------------------------------------------------------------------------
	app.endUndoGroup();
})();